/*
	core injected before this file
*/

(function(){

	var all 	= document.getElementsByTagName("*"),
	sources = [],
	test 	= new RegExp(core.proto,"gi"),
	exts 	= "";

	for(var i = 0; i < core.media.length; i++){
		for(var a = 0; a < core.media[i].file.length; a++){
			if(core.media[i].file[a].unc)continue;
			var est = core.media[i].file[a].ext.replace("(","").replace(")","");
			exts+=(exts.length < 1) ? est : "|" + est;
		}
	}
	exts = new RegExp("(" + exts + ")","gi");

	function _getProgress(val,max){
		if(!val || !max) return 100;

		var q = ( val / ( max / 100 ) );
		return (q.toFixed(0));
	};

	function _searchMetaSchema(){
		var objmetas = document.getElementsByTagName('meta');
		var tests=[
		'videourl',
		'video_url',
		'url_video',
		'urlvideo',
		'audiourl',
		'audio_url',
		'url_audio',
		'urlaudio'
		];
		var re = new RegExp(tests.join("|"), "gi");

		try{
			if(objmetas){
				for (var i = 0; i < objmetas.length; i++) {
					var attr_name = objmetas[i].getAttribute('name');
					if(attr_name){
						if(attr_name.match(re)){
							var attr_content=objmetas[i].getAttribute('content');
							sources.push("[META ("+attr_name+")] "+attr_content);						
						}
					}
				};
			}
		}catch(err){

		}
	};

	function _searchLocalStorage(){
		for (var key in localStorage){
			var source=unescape(unescape(localStorage[key]));
			if(source.match(test) || source.match(exts))sources.push("[LOCAL-STORAGE ("+key+")] "+source);
		}
	};

	function _searchCookie(){
		var ca = document.cookie.split(";");
		for(var i=0; i<ca.length; i++){
			var c = ca[i].trim(),
			v = c.split("=");

			if(!v[0] || !v[1])continue;

			if(v[1].match(test) || v[1].match(exts)){
				sources.push("[COOKIE ("+v[0]+")] "+v[1]);
			}		
		}
	};

	function _searchContentScript(){
		var s = document.getElementsByTagName("script"),
			open  	= new RegExp("<","gi"),
			close 	= new RegExp(">","gi");

		for(var i = 0; i < s.length; i++){
			var c 	= s[i].innerHTML.trim(),
				spc = c.split("\n");
				for(var a = 0; a < spc.length; a++){
					var line = spc[a].trim();
					if(line.length > 0 && (line.match(test) || line.match(exts)))sources.push("[CONTENT SCRIPT]  "+line.replace(open,"&lt;").replace(close,"&gt;"));
				}		
			//if(c && c.match(/(\.mp4|\.webm|\.avi|\.flv|\.mov|\.m3u8|\.mkv|\.mpeg|\.mpg|\.mp3)/gi))sources.push("CONTENT SCRIPT : "+c);	
		}
	};

	_searchMetaSchema();
	chrome.runtime.sendMessage({score:30});
	_searchLocalStorage();
	chrome.runtime.sendMessage({score:60});
	_searchCookie();
	chrome.runtime.sendMessage({score:70});
	_searchContentScript();
	chrome.runtime.sendMessage({score:90});

//search in attributes
for (var i = 0, max = all.length; i < max; i++) {
	var attrs 	= all[i].attributes,
	tagname = "[TAG (" + all[i].tagName + ")]  ";

	for (var a = 0; a < attrs.length; a++) {		
		var attry = "[ATTRIBUTE (" + attrs[a].nodeName + ")] " + attrs[a].nodeValue;
		if(!attrs[a].nodeValue)continue;
		if(attrs[a].nodeValue.match(test) || attrs[a].nodeValue.match(exts)){
			sources.push(tagname+attry);
		}
	}
}

chrome.runtime.sendMessage({sources:sources});

})();