
/*

	The CORE db inizialized in background.html.

*/
(function(G){
	if(!G) throw new Error("Background require Global vars and function !");

	var log			= G.log,
	allowed 		= /(http:|https:)/gi,
	sounds 			= {
		alert 	: chrome.extension.getURL("sounds/bell.ogg"),
		news 	: chrome.extension.getURL("sounds/ding.ogg")
	},
	times 			= 7000,
	notifyIframe 	= {
		id 			: "GAMiframe",
		option		: {
			type 		: "basic",
			title 		: "Grab Any Media auto esclude",
			message 	: "The controls for iframe was disabled for preserve the Memory and CPU",
			iconUrl 	: chrome.extension.getURL("img/Grab_Any_Media128_on.png"),
			buttons 	: [
				{
					title 		: "Not show alert again",
					iconUrl 	: chrome.extension.getURL("img/not-show.png")
				},
				{
					title 		: "Thanks mate",
					iconUrl 	: chrome.extension.getURL("img/show.png")
				}
			]
		},
		notShow 		: false,
		callback 		: function(notificationId){

			soundNotify(sounds.alert);
			//This for not show notification hide by system
			clearThisNotify(notificationId);
		},
		timeOut 		: null,
		seconds 		: (1000*60)*2 //show notifi after 2minute
	},
	notifyMessage 	= {
		id 			: "GAMmessage",
		option		: {
			type 		: "basic",
			title 		: "Grab Any Media news",
			message 	: "",
			iconUrl 	: chrome.extension.getURL("img/Grab_Any_Media128_on.png"),
			buttons 	: [
				{
					title 		: "View",
					iconUrl 	: chrome.extension.getURL("img/go.png")
				},
				{
					title 		: "Thanks mate",
					iconUrl 	: chrome.extension.getURL("img/show.png")
				}
			]
		},
		notShow 		: false,
		callback 		: function(notificationId){

			soundNotify(sounds.news);
			//This for not show notification hide by system
			clearThisNotify(notificationId);
		},
		timeOut 		: null,
		linkToOpen 		: "",
		seconds 		: (1000*60)*15 //check news
	},
	EXT 			= {
		extVersion  : G.config.extVersion,
		coreVersion : G.config.coreVersion
	};

	function soundNotify(track){
		try{
			if(!track)return false;

			var audio = new Audio(track);
			if(!audio)return false

				audio.canPlayType('audio/ogg');
			audio.play();
		}catch(e){
			//
		}	
	};
	//Reset db media and docs
	chrome.runtime.onStartup.addListener(function() {
		G.resetDbmediaAndDocs();
		controllIconBar();		
	});


	chrome.runtime.onInstalled.addListener(function(details) {
		switch(details.reason){
			case "install":
				G.resetAllDB();
				_gaq.push(['_trackEvent', "Installation", "Installed", JSON.stringify(EXT)]);
				break;
			case "update":
				G.resetAllDB();
				var ver 	= chrome.runtime.getManifest(),
					prev 	= details.previousVersion,
					mex 	= "";
				ver = ver.version;

				if(prev) mex = (parseInt(prev) < parseInt(ver)) ? "Updated from " + prev : "Refresh " + G.config.extVersion;
				_gaq.push(['_trackEvent', "Update", mex, JSON.stringify(EXT)]);
				break;
			case "chrome_update":
				_gaq.push(['_trackEvent', "Chrome Update", "Installed", JSON.stringify(EXT)]);
				break;
		}
		controllIconBar();	
	});

	chrome.runtime.onSuspend.addListener(function(){
		controllIconBar();
		_gaq.push(['_trackEvent', "Suspend", "Suspended", JSON.stringify(EXT)]);
	});

	function startNotifyIframe(){
		//Reitialize
		if(notifyIframe.timeOut)clearTimeout(notifyIframe.timeOut);

		notifyIframe.timeOut = setTimeout(function(){

			var a = G.getDBsettings(); 
				//If not setted not notifi
				if(!a.checkIFRAME)return false;
				
				a.checkIFRAME = false;
				G.setDBsettings(JSON.stringify(a));

				controllIconBar();
				
				chrome.notifications.getPermissionLevel(function(level){
					if(level == "granted" && !notifyIframe.notShow){
						chrome.notifications.create(notifyIframe.id,notifyIframe.option,notifyIframe.callback);												
					}
					clearTimeout(notifyIframe.timeOut);
				});
			},notifyIframe.seconds);
	};

	chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
		if(request.disableIFRAME){
			startNotifyIframe();
		}else if(request.checkIcon){
			controllIconBar();
		}
	});

	chrome.notifications.onButtonClicked.addListener(function(notificationId,buttonIndex){
		switch(notificationId){
			case notifyIframe.id:				
				if(buttonIndex === 0){
					notifyIframe.notShow = true;
				}				
				break;
			case notifyMessage.id:				
				if(buttonIndex === 0){
					//open link
					if(notifyMessage.linkToOpen.length > 0)chrome.tabs.create({url:notifyMessage.linkToOpen});
				}				
				break;
		}	
		//chrome.notifications.clear(notificationId, function(){});	
	});		

	chrome.notifications.onClosed.addListener(function(notificationId,byUser) {
		chrome.notifications.clear(notificationId, function(){});
	});			

	G.initialize();
	count_item();

	//Listner for request
	chrome.webRequest.onResponseStarted.addListener(function (details){
		
		try{
			check_request(details);
		}catch(e){
			log("Error onResponseStarted:" + e.message);
		}

	},{'urls': ['http://*/*', 'https://*/*', '*://*/*', '<all_urls>', '\u003Call_urls\u003E'],
		types: ['main_frame', 'sub_frame', 'script', 'object', 'xmlhttprequest', 'other']},['responseHeaders']);
		/*types: ['main_frame', 'sub_frame', 'stylesheet', 'script', 'image', 'object', 'xmlhttprequest', 'other']},['responseHeaders']);*/
	 
	function check_request(details){
		if(details.tabId < 0 || !details)return false;	
		
		var settings 	= G.getDBsettings();
		// Disabled
		if(settings.checkDG)return false;

		var oneKb 		= 1024, 
			oneMega 	= oneKb*1024,
			oneGiga 	= oneMega*1024;		
			headers 	= details.responseHeaders,
		 	size 		= null,
		 	sized 		= 0,
		 	octect 		= null,
		 	good 		= null,
		 	docs 		= null,
		 	link 		= decodeURIComponent(details.url.trim()),
		 	ext 		= dammiEstensione(link),
		 	core 		= G.getDBcore();
		
		

		if(!headers)return log("check_request() : No headers for :" + link);

		for ( var i= 0; i < headers.length; i++){
			if(size && octect)break;
			var header = headers[i];

			if (header.name.toLowerCase() == "content-length"){
				size 	= header.value;
				sized 	= header.value;			
				if(size < oneKb){
					size = size + " byte";
				}else if(size < oneMega){
					var decimaliKB = size/oneKb;	
					size = Math.round(decimaliKB*100)/100+' KB';
				}else if(size < oneGiga){
					var decimaliMB = size/oneMega;		
					size = Math.round(decimaliMB*100)/100+' MB';		
				}else{
					var decimaliGB = size/oneGiga;			
					size = Math.round(decimaliGB*100)/100+' GB';
				}							
			}
			
			if (header.name.toLowerCase() == 'content-type'){
				octect = header.value.toLowerCase().trim();
			}
		}//Exit for

		//size possible null updated on 4.0.0.3
		size = size || "0 byte (open with VLC)";

		//Check octect and ext for media, good not work here, but for testing
		if(octect && !good && (parseInt(sized) >= parseInt(settings.maxFileSize))){			
			for(var i = 0; i < core.media.length; i++){
				if(good)break;
				for(var a = 0; a < core.media[i].file.length; a++){				
					if(good)break;
					if((core.media[i].file[a].cod.indexOf("swf") != -1 && settings.checkSWF == false))continue;
					var test = new RegExp(core.media[i].file[a].oct,"gi");

					if(octect.match(test)){
						good = core.media[i].file[a].cod;
						break;
					}else if(ext){
						test = new RegExp(core.media[i].file[a].ext,"gi");
						if(ext.match(test)){
							good = core.media[i].file[a].cod;
							break;
						}
					}
				}
			}
		}//End check octect and ext


		//Check octect and ext for doc
		if(octect && !good){
			for(var i = 0; i < core.doc.length; i++){
				if(docs)break;
				for(var a = 0; a < core.doc[i].file.length; a++){
					if(docs)break;

					if(	(core.doc[i].file[a].cod == "js" && settings.checkJS == false)		||
						(core.doc[i].file[a].cod == "json" && settings.checkJSON == false)	||
						(core.doc[i].file[a].cod == "xml" && settings.checkXML == false)
					)	continue;

					var test = new RegExp(core.doc[i].file[a].oct,"gi");
					if(octect.match(test)){
						docs = core.doc[i].file[a].cod;
						break;
					}else if(ext){
						test = new RegExp(core.doc[i].file[a].ext,"gi");
						if(ext.match(test)){
							docs = core.doc[i].file[a].cod;
							break;
						}
					}
				}
			}
		}//End check octect and ext	

		//If do not find media or docs i check the iframe but
		//this capture most file set it in the settings
		if(details.frameId > 0 && settings.checkIFRAME && !good && !docs){
			docs = "IFRAME";
		}

		if(good){
			log("Save the Media");
			var db 		= G.getDBmedia(),
				schema 	= {
					url 	: link,
					id 		: MD5(link),
					ext 	: good,
					size 	: size,
					tabId 	: details.tabId
				};

			//var result = $.grep(db, function(e){return e.id == schema.id;}) || [];

			if(!G.findDBmedia(schema.id)){
				db.push(schema);
				G.setDBmedia(JSON.stringify(db));
				count_item();
				chrome.runtime.sendMessage({populate:true});
				/*
					Statistic for most media viewed over 2,5 MB size
				*/			
				if(parseInt(sized) > 2621440){				
					chrome.tabs.get(details.tabId,function(tab){
						var MMG = {
							title 		: tab.title,
							size 		: parseInt(sized),
							type 		: good,
							urlMedia 	: tab.url,
							urlSource 	: schema.url
						};
						
						_gaq.push(['_trackEvent', "Media Most Grabbed", JSON.stringify(MMG), JSON.stringify(EXT)]);
						var ws = dammiHost(tab.url);
						if(ws.length > 0){
							_gaq.push(['_trackEvent', "Domain Most Visited", ws, schema.url]);		
						}
						
					});				
				}			
			}			
			
		}else if(docs){
			log("Save the Docs");
			var db 		= G.getDBdocuments(),
				schema 	= {
					url 	: link,
					id 		: MD5(link),
					ext 	: docs,
					size 	: size,
					tabId 	: details.tabId
				};
			//var result = $.grep(db, function(e){return e.id == schema.id;}) || [];
			
			if(!G.findDBdocuments(schema.id)){
				db.push(schema);
				G.setDBdocuments(JSON.stringify(db));
				count_item();
			}		
		}
		//console.log("Good:"+good+"  docs:"+docs);				
	};

	//Restituisce l'estensione lo devo migliorare
	function dammiEstensione(indirizzo){	
		var ext = '';
		/*Test es: http://www.mysite.com/myfile.xml?p1=v1&........			ok
					http://www.mysite.com/myfolder/?p1=v1&........			no
					https://www.mysite.com/myfolder/js/k=gapi.gapi.en.xwY	no
					http://www.mysite.com/myfolder/myfile.jpg				ok
		*/	
		if (indirizzo.indexOf('?') > -1){
			var a = indirizzo.split('?');
			ext = a[0].split('.').pop().toString();
		}else{
			//es: no comment
			ext= indirizzo.split('.').pop().toString();		
		}	
		//no extension finded
		if(ext==null)return '';

		if (ext.indexOf('/')>-1 || ext.indexOf('=')>-1)return '';
		
		return "." + ext;
	};

	function dammiHost(indirizzo){
		try{
			var a = indirizzo.split('://');
			if(a.length < 2) return "";
			var b = a[1].split('/');
			if(b.length<1) return "";
			return b[0];
		}catch(err){
			return "";
		}
	};

	function count_item(){
		var db = G.getDBmedia(); 
		chrome.tabs.query(
		        {
		        	/*currentWindow: true,
		         	active: true*/
		         	windowId: chrome.windows.WINDOW_ID_CURRENT,
		         	active: true
		     	},function (tabs){
		     		if(tabs.length < 1)return false;
		        	var idTab = tabs[0].id;

					var result = $.grep(db, function(e){return e.tabId == idTab;});

					if(result.length < 1){
						chrome.browserAction.setBadgeText({text:"",tabId:idTab});
					}else{
						chrome.browserAction.setBadgeBackgroundColor({ color: [51, 0, 51, 230] });
						chrome.browserAction.setBadgeText({text:result.length+"",tabId:idTab});
					}				
				}
		);	
	};

	function removeItemFromID(idTab){
		if(idTab == undefined)return false;

		var db = G.getDBmedia(); 
		var result = $.grep(db, function(e){return e.tabId == idTab;});	

		if(result.length > 0){
			var c = db.filter( function ( elem ) {
				return result.indexOf( elem ) === -1;
			});		
			G.setDBmedia(JSON.stringify(c));
			return true;
		}

		db = G.getDBdocuments();  
		result = $.grep(db, function(e){return e.tabId == idTab;});	

		if(result.length > 0){
			var c = db.filter( function ( elem ) {
				return result.indexOf( elem ) === -1;
			});		
			G.setDBdocuments(JSON.stringify(c));
			return true;
		}

		return false;
	};

	function clearThisNotify(notificationId,time){
		if(!notificationId)return false;
		time = time || times;
		setTimeout(function(){
			chrome.notifications.clear(notificationId, function(){});
		},time);
	};

	chrome.tabs.onActivated.addListener(function(activeInfo) {
		count_item();
	});

	chrome.tabs.onUpdated.addListener(function(tabId, changeInfo, tab) {	
		if(changeInfo.status != 'complete')return false;
		count_item();
	});

	chrome.tabs.onRemoved.addListener(function(tabId,removeInfo) {
		removeItemFromID(tabId);
	});

	chrome.webNavigation.onBeforeNavigate.addListener(function(details) {
		if(details.frameId == 0)removeItemFromID(details.tabId);
	});

	chrome.windows.onRemoved.addListener(function(windowId) {
		chrome.tabs.query(
		        {
		        	windowId: windowId
		     	},function (tabs){
		     		if(tabs.length < 1)return false;

		     		for(var s = 0; s < tabs.length; s++){
		     			removeItemFromID(tabs[s].id);
		     		}			
				}
		);
	});

	function installMenu(){
		var a01 = chrome.contextMenus.create({"title": "Grab Any Media", "id":"main", "contexts":["all"]}),
			a02 = chrome.contextMenus.create({"title": "Active Iframe Check", "parentId": a01, "contexts":["all"], "onclick": function(info, tab){
					_gaq.push(['_trackEvent', "Context Menu", "Active Iframe Check", JSON.stringify(EXT)]);
					if(!tab.url.match(allowed))return alert("Only on http or https");
					var a = G.getDBsettings(); 
					
					a.checkDG 		= false;
					a.checkIFRAME 	= true;
					G.setDBsettings(JSON.stringify(a));
					
					controllIconBar();
					chrome.tabs.reload(null);
					startNotifyIframe();
				}
			}),
			a03 = chrome.contextMenus.create({"type":"separator", "parentId": a01, "contexts":["all"]}),
			a04 = chrome.contextMenus.create({"title": "Disable", "parentId": a01, "contexts":["all"], "onclick": function(info, tab){
					_gaq.push(['_trackEvent', "Context Menu", "Mode Disable", JSON.stringify(EXT)]);
					if(!tab.url.match(allowed))return alert("Only on http or https");
					var a = G.getDBsettings();
				
						a.checkDG 		= true;
						a.checkIFRAME 	= false;

						G.setDBsettings(JSON.stringify(a));
						controllIconBar();
						startNotifyIframe();	
						count_item();
				}
			}),
			a05 = chrome.contextMenus.create({"title": "Aggressive", "parentId": a01, "contexts":["all"], "onclick": function(info, tab){
					_gaq.push(['_trackEvent', "Context Menu", "Mode Aggressive", JSON.stringify(EXT)]);
					if(!tab.url.match(allowed))return alert("Only on http or https");
					var a = G.getDBsettings();
						
						a.checkDG 		= false;
						a.checkIFRAME 	= true;
						a.checkJS 		= true;
						a.checkJSON 	= true;
						a.checkXML 		= true;	
						a.checkSWF 		= true;
						a.maxFileSize 	= 0;	

						G.setDBsettings(JSON.stringify(a));	
						controllIconBar();
						chrome.tabs.reload(null);
						startNotifyIframe();
				}
			}),
			a06 = chrome.contextMenus.create({"title": "Moderate", "parentId": a01, "contexts":["all"], "onclick": function(info, tab){
					_gaq.push(['_trackEvent', "Context Menu", "Mode Moderate", JSON.stringify(EXT)]);
					if(!tab.url.match(allowed))return alert("Only on http or https");
					var a = G.getDBsettings();
						
						a.checkDG 		= false;
						a.checkIFRAME 	= true;
						a.checkJS 		= false;
						a.checkJSON 	= true;
						a.checkXML 		= true;		
						a.checkSWF 		= false;
						a.maxFileSize 	= 1572864;	

						G.setDBsettings(JSON.stringify(a));	
						controllIconBar();
						chrome.tabs.reload(null);
						startNotifyIframe();
				}
			}),
			a07 = chrome.contextMenus.create({"title": "Normal", "parentId": a01, "contexts":["all"], "onclick": function(info, tab){
					//if(!tab.url.match(allowed))return alert("Only on http or https");
					_gaq.push(['_trackEvent', "Context Menu", "Mode Normal", JSON.stringify(EXT)]);
					var a = G.getDBsettings();
						
						a.checkDG 		= false;
						a.checkIFRAME 	= false;
						a.checkJS 		= false;
						a.checkJSON 	= true;
						a.checkXML 		= true;		
						a.checkSWF 		= false;
						a.maxFileSize 	= 2621440;	

						G.setDBsettings(JSON.stringify(a));	
						
						controllIconBar();
						/*chrome.browserAction.setBadgeBackgroundColor({ color: [255, 0, 0, 255] });
						chrome.browserAction.setBadgeText({text:"OK",tabId:tab.id});*/
						//setTimeout(count_item,2000);
						chrome.tabs.reload(null);
						startNotifyIframe();
				}
			}),
			a08 = chrome.contextMenus.create({"type":"separator", "parentId": a01, "contexts":["selection"]}),
			a09 = chrome.contextMenus.create({"title": "Search Video (selected text)", "parentId": a01, "contexts":["selection"], "onclick": function(info, tab){
					_gaq.push(['_trackEvent', "Context Menu", "Search Video ' " + info.selectionText + " '", JSON.stringify(EXT)]);
					chrome.tabs.create({url:G.config.site + G.config.searchPage + encodeURIComponent(info.selectionText)});
				}
			});					

	};

	function controllIconBar(){
		var a = G.getDBsettings();

		if(a.checkDG){

			chrome.browserAction.setTitle({title:"Grab Any Media [Disabled]"});
			chrome.browserAction.setIcon({path: G.config.iconDisabled});

		}else if(!a.checkJS && a.checkJSON && a.checkXML && !a.checkSWF && !a.checkIFRAME && a.maxFileSize == 2621440){
			
			chrome.browserAction.setTitle({title:"Grab Any Media [Normal]"});
			chrome.browserAction.setIcon({path: G.config.iconStandard});
		
		}else if(!a.checkJS && a.checkJSON && a.checkXML && !a.checkSWF && a.checkIFRAME && a.maxFileSize == 1572864){
			
			chrome.browserAction.setTitle({title:"Grab Any Media [Moderate]"});
			chrome.browserAction.setIcon({path: G.config.iconModerate});

		}else if(a.checkJS && a.checkJSON && a.checkXML && a.checkSWF && a.checkIFRAME && a.maxFileSize < 1){
			
			chrome.browserAction.setTitle({title:"Grab Any Media [Aggressive]"});
			chrome.browserAction.setIcon({path: G.config.iconAggressive});
		
		}else{
			
			chrome.browserAction.setTitle({title:"Grab Any Media [Custom]"});
			chrome.browserAction.setIcon({path: G.config.iconCustom});
		
		}	
	};
	

	function checkNewsForNotify(){
		log("Grab Any Media : Check last news ");
		var xhr = $.ajax({
			type:"GET",
			url: G.config.site + G.config.newsPage,
			dataType: "json",
			cache: false,
			success: function(data){
				if(data){
					if(!data.link || !data.message){
						_gaq.push(['_trackEvent', "Bug", "checkNewsForNotify() return invalid data", JSON.stringify(EXT)]);
						return false;
					}
					var datas = JSON.stringify(data);
					if(!G.compareDBlastnews(datas)){
						G.setDBlastnews(datas);
						//show popup with data.link and data.message
						chrome.notifications.getPermissionLevel(function(level){
							if(level == "granted" && !notifyMessage.notShow){
								notifyMessage.option.message = data.message;
								notifyMessage.linkToOpen = data.link;
								chrome.notifications.create(notifyMessage.id,notifyMessage.option,notifyMessage.callback);												
							}
						});
					}
				}										
			}
		});
	};

	//Updated on 4.0.0.6 for not duplicate menu in update extension
	chrome.contextMenus.removeAll(installMenu);
	
	checkNewsForNotify();
	//Check last-news
	setInterval(checkNewsForNotify,notifyMessage.seconds);

	_gaq.push(['_trackEvent', "New Session", "Version " + G.config.extVersion, "CORE " + G.config.coreVersion]);

})(GLB);
