
(function (W,D,$,C,S,G){
	//Controll for jQuery and CORE
	if(!$) throw new Error("GAM require jQuery !");
	if(!C || !S) throw new Error("GAM require CORE !");
	if(!G) throw new Error("GAM require Global vars and function !");

	//Private vars	
	var log 	= G.log;

	//Private constant	
	var CONST	= {		
		advanced 	: "js/advanced-source.js",
		main 		: "#main",
		container 	: "#container",
		templates 	: {
			board 		: G.config.path + "tlp/board.html",
			preload 	: G.config.path + "tlp/preload.html",
			mediaitem 	: G.config.path + "tlp/media-item.html",
			scannitem 	: G.config.path + "tlp/scanning-item.html"
		},
		scripts 	: {
			popuplinks 	: G.config.path + "js/popup-link.js",
			popupsource : G.config.path + "js/popup-source.js",
			jquery		: G.config.path + "js/jquery.min.js"
		},
		style 		: {
			bootstrap 	: G.config.path + "css/bootstrap-theme.css",
			favicon 	: G.config.path + "img/Grab_Any_Media16_off.png"
		},
		shares 		: {
			facebook 	: "https://www.facebook.com/sharer/sharer.php?u=" + G.config.site,
			twitter 	: "https://twitter.com/share?url=" + G.config.site,
			google 		: "https://plus.google.com/share?url=" + G.config.site
		},
		allowed 	: /(http:|https:)/gi, 
	},
	EXT 			= {
		extVersion  : G.config.extVersion,
		coreVersion : G.config.coreVersion
	};

	//GAM object
	GAM = function(opt){
		opt = opt || {
			debug : false
		};

		if(opt.debug)O = true;

		chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
			if(request.populate){
				_populate();
			}
		});

		if (!(window!=window.top)) {
			//Reset local data pupup when popup closed
			localStorage.removeItem("popupdata");
			localStorage.removeItem("popupsources");
			localStorage.removeItem("popuplinks");
		}
	};

	GAM.prototype = {
		version  	: function(){return G.config.extVersion;},
		core 	 	: function(){return C.version}
	}; 

	function _signDataForPopup(data,sources,links){
		localStorage['popupdata'] = data;
		localStorage['popupsources'] = JSON.stringify(sources);
		localStorage['popuplinks'] = JSON.stringify(links);
	};

	function _getMaxFileSize(){
		var a = G.getDBsettings();
		return a.maxFileSize;
	};

	function _getCheckDG(){
		var a = G.getDBsettings();
		return a.checkDG;
	};

	function _getCheckJS(){
		var a = G.getDBsettings();
		return a.checkJS;
	};

	function _getCheckJSON(){
		var a = G.getDBsettings();
		return a.checkJSON;
	};

	function _getCheckXML(){
		var a = G.getDBsettings();
		return a.checkXML;
	};

	function _getCheckIFRAME(){
		var a = G.getDBsettings();
		return a.checkIFRAME;
	};

	function _getCheckSWF(){
		var a = G.getDBsettings();
		return a.checkSWF;
	};

	function _setMaxFileSize(val){
		if(typeof val === "undefined")return false;

		var a = G.getDBsettings();
		a.maxFileSize = val;
		G.setDBsettings(JSON.stringify(a));
	};

	function _setBoxDG(val){
		if(typeof val === "undefined")return false;

		var a = G.getDBsettings();
		a.checkDG = val;
		G.setDBsettings(JSON.stringify(a));
	};

	function _setBoxJS(val){
		if(typeof val === "undefined")return false;

		var a = G.getDBsettings();
		a.checkJS = val;
		G.setDBsettings(JSON.stringify(a));
	};

	function _setBoxJSON(val){
		if(typeof val === "undefined")return false;

		var a = G.getDBsettings();
		a.checkJSON = val;
		G.setDBsettings(JSON.stringify(a));
	};

	function _setBoxXML(val){
		if(typeof val === "undefined")return false;

		var a = G.getDBsettings();
		a.checkXML = val;
		G.setDBsettings(JSON.stringify(a));
	};

	function _setBoxIFRAME(val){
		if(typeof val === "undefined")return false;

		var a = G.getDBsettings();
		a.checkIFRAME = val;
		G.setDBsettings(JSON.stringify(a));
	};

	function _setBoxSWF(val){
		if(typeof val === "undefined")return false;

		var a = G.getDBsettings();
		a.checkSWF = val;
		G.setDBsettings(JSON.stringify(a));
	};

	//Private function for show main body
	function _showMain(duration, onloaded){
		duration = duration || 500;

		$(CONST.main).show("bounce",duration,function(){
			if(typeof onloaded === "function")return onloaded();
		});
	};
	//Private function for show preload
	function _showPreload(where,onloaded){
		where = where || CONST.container;

		$(where).load(CONST.templates.preload, function(){
			if(typeof onloaded === "function")onloaded();
		});
	};

	function _getPercentage(val,max){
		if(!val || !max) return 100;

		var q = ( val / ( max / 100 ) );
		return (100 - q.toFixed(0));

	};

	function _enableSettings(val){

		if(val == true){

			$("#opt-disable").removeAttr("disabled");
		
		}else{

			$("#opt-disable").attr("disabled", "disabled");

		}

	}

	//Private function for append event of template
	function _appendEventToBoard(){

		var db 	= G.getDBdocuments(),
		links 	= [],
		sources = [];
		chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
			if(request.sources){
				sources = request.sources;
				$("#progress-value").attr("style","width:100%");
				$("#advanced-start").button("reset");
				$("#show-advanced-progress").fadeOut(500, function(){
					if(links.length < 1 && sources.length < 1){
						$("#response-no-found").fadeIn(500);
					}else{
						var all = "";
						$.get(CONST.templates.scannitem,function(data){	        			
		        			for (var i = 0; i < links.length; i++) {
		        				var item = data;
		        				item = item.replace(/(\%id\%)/gi,links[i].id);
		        				item = item.replace(/(\%link\%)/gi,"");
		        				item = item.replace(/(\%type\%)/gi,links[i].ext);
		        				item = item.replace(/(\%mini\%)/gi,_minify(57,links[i].url));
		        				all+=item;
		        			}
		        			for (var i = 0; i < sources.length; i++) {
		        				var item 	= data,
		        					ids 	= MD5(sources[i]);
		        				item = item.replace(/(\%id\%)/gi,ids);
		        				item = item.replace(/(\%link\%)/gi,"");
		        				item = item.replace(/(\%type\%)/gi,"Source");
		        				item = item.replace(/(\%mini\%)/gi,_minify(57,sources[i]));
		        				all+=item;		        				
		        			}

		        			$("#advanced").html(all);
		        			$(".hideorshow").hide();
		        			_signDataForPopup(all,sources,links);
		        			
							//Append event for id
							for (var i = 0; i < links.length; i++) {
								var ids 	= links[i].id;
								$("."+ids).attr("data-response",links[i].url);		        				
								$("."+ids).on("click",function(){		        					
									top.consoleRef=window.open('','console',
										'width=600,height=600'
										+',menubar=0'
										+',toolbar=1'
										+',status=0'
										+',scrollbars=1'
										+',resizable=1')
									top.consoleRef.document.writeln(
										"<html><head><title>Grab Any Media files loaded</title><meta charset='utf-8'>"
										+"<link rel='icon' type='image/png' href='"+CONST.style.favicon+"'/>"
										+"<link href='"+CONST.style.bootstrap+"' type='text/css' rel='stylesheet'>"
										+"<script id='popup' type='text/javascript' src='"+CONST.scripts.popuplinks+"?"+encodeURIComponent($(this).attr("data-response"))+"'></script>"
										+"<script onload='LOAD();' type='text/javascript' src='"+CONST.scripts.jquery+"'></script></head>"
										+"<body bgcolor=white onLoad='self.focus()'>"
										+"<div id='header'><h5 class='text-left'>Loading ...</h5></div><div id='container'></div></body></html>"									
										)
									top.consoleRef.document.close();
									return false;
								});
							}
							for (var i = 0; i < sources.length; i++) {
								var ids 	= MD5(sources[i]);
								$("."+ids).attr("data-response",sources[i]);		        				
								$("."+ids).on("click",function(){		        					
									top.consoleRef=window.open('','console',
										'width=600,height=600'
										+',menubar=0'
										+',toolbar=1'
										+',status=0'
										+',scrollbars=1'
										+',resizable=1')
									top.consoleRef.document.writeln(
										"<html><head><title>Grab Any Media source</title><meta charset='utf-8'>"
										+"<link rel='icon' type='image/png' href='"+CONST.style.favicon+"'/>"
										+"<link href='"+CONST.style.bootstrap+"' type='text/css' rel='stylesheet'>"
										+"<script id='popup' type='text/javascript' src='"+CONST.scripts.popupsource+"'></script>"
										+"<script onload='LOAD();' type='text/javascript' src='"+CONST.scripts.jquery+"'></script></head>"
										+"<body bgcolor=white onLoad='self.focus()'>"
										+"<div id='header'><h5 class='text-left'>Loading ...</h5></div><div id='container'>"+$(this).attr("data-response")+"</div></body></html>"									
										)
									top.consoleRef.document.close();
									return false;
								});
							}
							$(".hideorshow").fadeIn(500);
		        		});	    
					}									
				});
			}else if(request.score){
				$("#progress-value").attr("style","width:"+request.score+"%");						
			}
		});
		
		$("#frame-now").on("click",function(){
			if(typeof localStorage['popupdata'] === "undefined")localStorage['popupdata'] = "";
			if(typeof localStorage['popupsources'] === "undefined")localStorage['popupsources'] = "[]";
			if(typeof localStorage['popuplinks'] === "undefined")localStorage['popuplinks'] = "[]";
			var scanned = localStorage['popupdata'],
				sources = JSON.parse(localStorage['popupsources']),
				links 	= JSON.parse(localStorage['popuplinks']);

			if(scanned.length < 1)return alert("Use new popup if you have Advanced response !");
			_gaq.push(['_trackEvent', "New PopUp", "Opened", JSON.stringify(EXT)]);
			top.consoleRef=window.open('','myconsole',
				'width=482,height=450'
				+',menubar=0'
				+',toolbar=1'
				+',status=0'
				+',scrollbars=0'
				+',resizable=0')
			top.consoleRef.document.writeln(
				"<html><head><title>Grab Any Media</title></head>"
				+"<link rel='icon' type='image/png' href='"+CONST.style.favicon+"'/>"
				+"<body bgcolor='white' onLoad='self.focus()' style='padding:0px;margin:0px;overflow:hidden'>"
				+"<iframe src='"+G.config.path+"popup.html' scrolling='no' style='overflow:hidden;position:absolute;top:0px;left:0px;border:none;width:465px;height:415px'>"
				+"</body></html>"
				)
			top.consoleRef.document.close();
			return false;
		});		
		
		//Detect dragging bookmarklets
		$(function() {
			var isDragging = false;
			$(".bookmarklets")
			.mousedown(function() {
				var iam = $(this);
				$(window).mousemove(function() {
					isDragging = true;
					_gaq.push(['_trackEvent', "Bookmarklets", "Dragged ' " + iam.html() + " '", JSON.stringify(EXT)]);
					$(window).unbind("mousemove");
				});
			})
			.mouseup(function() {
				var wasDragging = isDragging;
				isDragging = false;
				$(window).unbind("mousemove");
				if (!wasDragging) {
					//click event is good not this for intercept the click						
				}
			}).click(function(){
				_gaq.push(['_trackEvent', "Bookmarklets", "Clicked ' " + $(this).html() + " '", JSON.stringify(EXT)]);
				alert("Drag me on bookmarklets toolbar, this work on all browser.");
				return false;
			});
		});

		$("#search-videos").on("click",function(e){
			_gaq.push(['_trackEvent', "Search Terms", $("#videos-terms").val(), JSON.stringify(EXT)]);
			chrome.tabs.create({url:G.config.site + G.config.searchPage + encodeURIComponent($("#videos-terms").val())});
		});

		$("#videos-terms").on("keypress",function(e){
			if(e.which == 13 )$("#search-videos").click();
		});

		$(".copy-user-agent").on("click",function(){	
			$("#clipboard").html("");						
			$("#clipboard").show();
			$("#clipboard").html(navigator.userAgent).focus();
			document.execCommand('SelectAll');
			document.execCommand("Copy", false, null);
			$("#clipboard").html("");
			$("#clipboard").hide();
			var spot = $(this).children(".spot-copy-UA");
			spot.html(" copied").fadeIn(500,function(){
				spot.fadeOut(1000);
			});
		});
		$("#ext-version").html(G.config.extVersion + " ");
		$("#core-version").html(C.version + " ");
		$("#core-version-update").html(C.message);

		$("#check-update").on("click",function(){
			_chekUpdateOrCore();
		});

		$("#restore-core").on("click",function(){
			C = G.signCore(S);
			$("#core-version").html(C.version + " ");
			$("#core-version-update").html(C.message);//Confirm the restore
			_gaq.push(['_trackEvent', "Core Restore", "Restored", JSON.stringify(EXT)]);
		});

		$("#max-file-size").val(_getMaxFileSize());
		$("#max-file-size").on("change",function(){
			_setMaxFileSize($(this).val());
			chrome.runtime.sendMessage({checkIcon:true});
			_gaq.push(['_trackEvent', "Max File Size", $(this).val(), JSON.stringify(EXT)]);
		});
		
		$("#box-DG").attr("checked",_getCheckDG());
		$("#box-js").attr("checked",_getCheckJS());
		$("#box-json").attr("checked",_getCheckJSON());
		$("#box-xml").attr("checked",_getCheckXML());
		$("#box-iframe").attr("checked",_getCheckIFRAME());
		$("#box-swf").attr("checked",_getCheckSWF());

		_enableSettings(!_getCheckDG());

		$("#box-DG").change(function() {
			if($(this).is(":checked")) {
				_setBoxDG(true);
				_enableSettings(false);
			}else{
				_setBoxDG(false);
				_enableSettings(true);
			} 
			chrome.runtime.sendMessage({checkIcon:true});     
	    });

		$("#box-js").change(function() {
			if($(this).is(":checked")) {
				_setBoxJS(true);
			}else{
				_setBoxJS(false);
			} 
			chrome.runtime.sendMessage({checkIcon:true});     
	    });

	    $("#box-json").change(function() {
			if($(this).is(":checked")) {
				_setBoxJSON(true);
			}else{
				_setBoxJSON(false);
			}      
			chrome.runtime.sendMessage({checkIcon:true});
	    });

	    $("#box-xml").change(function() {
			if($(this).is(":checked")) {
				_setBoxXML(true);
			}else{
				_setBoxXML(false);
			}     
			chrome.runtime.sendMessage({checkIcon:true}); 
	    });

	    $("#box-swf").change(function() {
			if($(this).is(":checked")) {
				_setBoxSWF(true);
			}else{
				_setBoxSWF(false);
			}     
			chrome.runtime.sendMessage({checkIcon:true}); 
	    });

	    $("#box-iframe").change(function() {
			if($(this).is(":checked")) {
				_setBoxIFRAME(true);				
			}else{
				_setBoxIFRAME(false);
			}
			//execute every click becouse some problem encounter
			chrome.runtime.sendMessage({disableIFRAME:true}); 
			chrome.runtime.sendMessage({checkIcon:true});      
	    });

	    $(".tooltip-iframe").tooltip({
	    	animation:true,
	    	title:"Attention, if you enable iframe i disable this after 2min",
	    	trigger:"hover"
	    }); 

		$("#advanced-start").on("click",function(){
			chrome.tabs.getSelected(null,function(tab) {
			    if(!tab.url.match(CONST.allowed))return alert("Only on http or https");
				_gaq.push(['_trackEvent', "Advantage Search", tab.url, JSON.stringify(EXT)]);
			    $("#response-no-found").hide();
			    $("#progress-value").attr("style","width:0%");
			    $("#advanced-start").button("loading");

			    $("#show-advanced-progress").fadeIn(500, function(){				
				//Check file loaded split for proto and ext file becouse it's long
				var test = new RegExp(C.proto,"gi"),
					exts = "";
				for(var i = 0; i < C.media.length; i++){
					for(var a = 0; a < C.media[i].file.length; a++){
						if(C.media[i].file[a].unc)continue;
						var est = C.media[i].file[a].ext.replace("(","").replace(")","");
						exts+=(exts.length < 1) ? est : "|" + est;
					}
				}
				exts = new RegExp("(" + exts + ")","gi");

				var searchs = function(obj,callback,max){
					var val = _getPercentage(obj.length,max);
					$("#progress-value").attr("style","width:"+val+"%");
					$("#advanced-current").html("Files loaded "+max);
					if(!obj)return callback();
					if(obj.length < 1) return callback();

					var exam = obj[0]; obj.splice(0,1);

					var xhr = $.ajax({
						type:"GET",
						url: exam.url,
						dataType: "html",
						cache: true,
						success: function(data){							
							if(!data) return searchs(obj,callback,max);							
							
							if(data.match(test) || data.match(exts)){
								links.push(exam);
								$("#advanced-found").html(links.length);
							}
							return searchs(obj,callback,max);
						},
						error: function () {
							return searchs(obj,callback,max);
						} 
					});
				};

				var intrude = function(idTab){
					$("#progress-value").attr("style","width:0%");
					$("#advanced-current").html("Source");
					chrome.tabs.executeScript(idTab, {code: "var core = "+JSON.stringify(C)+";"}, function(){
						chrome.tabs.executeScript(idTab, {file:CONST.advanced});
					});
					
				};

				chrome.tabs.query(
				{
				        	/*currentWindow: true,
				        	active: true*/
				        	windowId: chrome.windows.WINDOW_ID_CURRENT,
				        	active: true
				        },function (tabs){
				        	if(tabs.length < 1)return false;
				        	var idTab = tabs[0].id;

				        	var result = $.grep(db, function(e){return e.tabId == idTab;});
				        	if(result.length < 1){
				        		intrude(idTab);
				        	}else{
				        		searchs(result,function(){intrude(idTab)},result.length);
				        	}				
				        }
				        );	
				});
			});			
		});	

		/*$(".share-facebook").on("click",function(){
			_gaq.push(['_trackEvent', "Facebook", "Shared", G.config.extVersion]);
		});

		$(".share-twitter").on("click",function(){
			_gaq.push(['_trackEvent', "Twitter", "Shared", G.config.extVersion]);
		});

		$(".share-google").on("click",function(){
			_gaq.push(['_trackEvent', "Google", "Shared", G.config.extVersion]);
		});		*/
	};

	function _chekUpdateOrNews(){
		//Check update first
		var xhr = $.ajax({
			type:"POST",
			url: G.config.site + G.config.checkPage,
			dataType: "json",
			data: {ver:G.config.extVersion,id:chrome.runtime.id},
			cache: false, 
			success: function(data){
				data.message 		= data.message || "Problem on load news ...";
				data.lastversion 	= data.lastversion || 0;
				data.error 			= data.error || "";
				log("GAM update response : " + JSON.stringify(data));

				if(data.lastversion > G.config.extVersion){
					$("#ads").html(data.message);
					$(".update_now").on("click",function(){
						chrome.tabs.create({url:G.config.updatePath});
					});
				}else{
					xhr = $.ajax({
						type:"GET",
						url: G.config.site + G.config.lastCore,
						dataType: "json",
						cache: false,
						success: function(data){							
							if(data.version > C.version){
								$("#ads").html("New Core available, go to Info tab");
							}else{
								xhr = $.ajax({
									type:"GET",
									url: G.config.site + G.config.newsPage,
									dataType: "json",
									cache: false,
									success: function(data){
										if(!data){
											$("#ads").html("Problem on load news ...");
										}else{
											G.setDBlastnews(JSON.stringify(data));
											var l = "<a href='"+data.link+"' target='blank' title='"+data.message+"'>"+_minify(40,data.message)+"</a>";
											$("#ads").html(l);
										}										
									},
									error: function () {
										$("#ads").html("Problem on load news ...");
									} 
								});
							}										                	
						},
						error: function () {
							$("#ads").html("Problem on load news ...");
						} 
					});
				}					    					
			},
			error: function () {
				$("#ads").html("Problem on load news ..."); 
			}      
		});								
	};

	function _chekUpdateOrCore(){
		//Check update first
		$("#ext-version-update").html("Loading ...");
		$("#core-version-update").html("Loading ...");
		$("#check-update").button('loading');
		_gaq.push(['_trackEvent', "Core Check Update", "Checked", JSON.stringify(EXT)]);
		var check = 0;
		var xhr = $.ajax({
			type:"POST",
			url: G.config.site + G.config.checkPage,
			dataType: "json",
			data: {ver:G.config.extVersion,id:chrome.runtime.id},
			cache: false, 
			success: function(data){
				check++; if(check >= 2)$("#check-update").button('reset');
				log("GAM update response : " + JSON.stringify(data));
				data.message 		= data.message || "Problem on check";
				data.lastversion 	= data.lastversion || 0;
				data.error 			= data.error || "";

				if(!data){
					$("#ext-version-update").html("Problem on check");
				}else if(data.lastversion > G.config.extVersion){
					$("#ext-version-update").html(data.message);
					$(".update_now").on("click",function(){
						chrome.tabs.create({url:G.config.updatePath});
					});
				}else{
					$("#ext-version-update").html("This is last version");
				}					    					
			},
			error: function () {
				check++; if(check >= 2)$("#check-update").button('reset');
				$("#ext-version-update").html("Problem on check"); 
			}      
		});

		var xhr2 = $.ajax({
			type:"GET",
			url: G.config.site + G.config.lastCore,
			dataType: "json",
			cache: false,
			success: function(data){
				check++; if(check >= 2)$("#check-update").button('reset');
				log("GAM update response : " + JSON.stringify(data));
				
				if(!data){
					$("#core-version-update").html("Problem on check");
				}else if(data.version > C.version){
					C = G.signCore(data);
					$("#core-version-update").html(data.message);					
					$("#core-version").html(C.version + " ");
					_gaq.push(['_trackEvent', "Core Update", "Updated", JSON.stringify(EXT)]);
				}else{
					$("#core-version-update").html("This is last version");
				}									                	
			},
			error: function () {
				check++; if(check >= 2)$("#check-update").button('reset');
				$("#core-version-update").html("Problem on check");
			} 
		});								
	};

	function _minify(len,str){
		if(!str)return "";
		len = len || 10;

		if(str.length <= len) return str
		return str.substring(0,len) + "...";
	};

	function _populate(){
		var db 	= G.getDBmedia(),
			all = "";
		if(!db)return false;
			
		chrome.tabs.query(
			{
	        	windowId: chrome.windows.WINDOW_ID_CURRENT,
	        	active: true
	        },function (tabs){
	        	if(tabs.length < 1)return false;
	        	var idTab = tabs[0].id;

	        	var result = $.grep(db, function(e){return e.tabId == idTab;});
	        	if(result.length > 0){
	        		$.get(CONST.templates.mediaitem,function(data){	        			
	        			for (s in result) {
	        				var item = data;
	        				if(!result[s])continue;
	        				item = item.replace(/(\%link\%)/gi,result[s].url);
	        				item = item.replace(/(\%size\%)/gi,result[s].size);
	        				item = item.replace(/(\%type\%)/gi,result[s].ext.toUpperCase());
	        				item = item.replace(/(\%mini\%)/gi,_minify(70,result[s].url));
	        				all+=item;
	        			}
						if(all)$("#media").html(all);
						//append event for copy link
						$(".download-link").on("click",function(){								
  							var spot 	= $(this).children(".spot-download"),
  								url 	= $(this).attr("destiny");

  							spot.html(" downloading").fadeIn(500,function(){
  								chrome.downloads.download({
  									url 			: url,
  									conflictAction 	: "prompt",
  									saveAs 			: true
  								}, function(downloadId){
  									if(typeof downloadId === "undefined"){
  										alert("Error on download, please restart this download !");
  										_gaq.push(['_trackEvent', "Downloads", "Errors : " + url, JSON.stringify(EXT)]);
  										spot.html(" error");
  									}else{
  										_gaq.push(['_trackEvent', "Downloads", url, JSON.stringify(EXT)]);
  										spot.html(" prompt").fadeOut(1500);
  									}
  								});  								
  							});
  							return false;
						});
						$(".copy-link").on("click",function(){	
							$("#clipboard").html("");						
							$("#clipboard").show();
							$("#clipboard").html($(this).attr("data-copy")).focus();
							document.execCommand('SelectAll');
  							document.execCommand("Copy", false, null);
  							$("#clipboard").html("");
  							$("#clipboard").hide();
  							var spot = $(this).children(".spot-copy");
  							spot.html(" copied").fadeIn(500,function(){
  								spot.fadeOut(1000);
  							});
  							_gaq.push(['_trackEvent', "Copies", $(this).attr("data-copy"), JSON.stringify(EXT)]);
						});
	        		});	        		        			        		
	        	}				
	        }
	    );			
	};

	function _checkIframe(){
		if (window!=window.top) {
			$("#frame-now").attr("disabled","disabled");
			$("#tab-media").attr("style","display:none");
			$("#main-tab a[href='#advanced']").tab("show");

			if(typeof localStorage['popupdata'] === "undefined")localStorage['popupdata'] = "<h5>Problem with popup data Advanced !</h5>";
			if(typeof localStorage['popupsources'] === "undefined")localStorage['popupsources'] = "[]";
			if(typeof localStorage['popuplinks'] === "undefined")localStorage['popuplinks'] = "[]";

			$("#advanced").html(localStorage['popupdata']);
			var sources = JSON.parse(localStorage['popupsources']),
				links 	= JSON.parse(localStorage['popuplinks']);
			//Append event for id
			for (var i = 0; i < links.length; i++) {
				var ids 	= links[i].id;
				$("."+ids).attr("data-response",links[i].url);		        				
				$("."+ids).on("click",function(){		        					
					top.consoleRef=window.open('','console',
						'width=600,height=600'
						+',menubar=0'
						+',toolbar=1'
						+',status=0'
						+',scrollbars=1'
						+',resizable=1')
					top.consoleRef.document.writeln(
						"<html><head><title>Grab Any Media files loaded</title><meta charset='utf-8'>"
						+"<link rel='icon' type='image/png' href='"+CONST.style.favicon+"'/>"
						+"<link href='"+CONST.style.bootstrap+"' type='text/css' rel='stylesheet'>"
						+"<script id='popup' type='text/javascript' src='"+CONST.scripts.popuplinks+"?"+encodeURIComponent($(this).attr("data-response"))+"'></script>"
						+"<script onload='LOAD();' type='text/javascript' src='"+CONST.scripts.jquery+"'></script></head>"
						+"<body bgcolor=white onLoad='self.focus()'>"
						+"<div id='header'><h5 class='text-left'>Loading ...</h5></div><div id='container'></div></body></html>"									
						)
					top.consoleRef.document.close();					
					return false;
				});
			}
			for (var i = 0; i < sources.length; i++) {
				var ids 	= MD5(sources[i]);
				$("."+ids).attr("data-response",sources[i]);		        				
				$("."+ids).on("click",function(){		        					
					top.consoleRef=window.open('','console',
						'width=600,height=600'
						+',menubar=0'
						+',toolbar=1'
						+',status=0'
						+',scrollbars=1'
						+',resizable=1')
					top.consoleRef.document.writeln(
						"<html><head><title>Grab Any Media source</title><meta charset='utf-8'>"
						+"<link rel='icon' type='image/png' href='"+CONST.style.favicon+"'/>"
						+"<link href='"+CONST.style.bootstrap+"' type='text/css' rel='stylesheet'>"
						+"<script id='popup' type='text/javascript' src='"+CONST.scripts.popupsource+"'></script>"
						+"<script onload='LOAD();' type='text/javascript' src='"+CONST.scripts.jquery+"'></script></head>"
						+"<body bgcolor=white onLoad='self.focus()'>"
						+"<div id='header'><h5 class='text-left'>Loading ...</h5></div><div id='container'>"+$(this).attr("data-response")+"</div></body></html>"									
						)
					top.consoleRef.document.close();
					return false;
				});
			}			
		}
	};

	//Private function for show container
	function _showBoard(){
		var tlp	= CONST.templates.board;

		_showPreload(null,function(){
			$.get(tlp,function(data){
				
				$(CONST.container).fadeOut("slow", function(){
					$(CONST.container).html(data);
					_appendEventToBoard();
					_populate();
					_checkIframe();
					$(CONST.container).fadeIn("slow",function(){
						if(tlp == CONST.templates.board){
							$(".share-facebook").on("click",function(){
								W.open(CONST.shares.facebook,"_blank","height=400,width=600");
								_gaq.push(['_trackEvent', "Shared", "Facebook", JSON.stringify(EXT)]);
							});
							$(".share-twitter").on("click",function(){
								W.open(CONST.shares.twitter,"_blank","height=400,width=600");
								_gaq.push(['_trackEvent', "Shared", "Twitter", JSON.stringify(EXT)]);
							});
							$(".share-google").on("click",function(){
								W.open(CONST.shares.google,"_blank","height=400,width=600");
								_gaq.push(['_trackEvent', "Shared", "Google+", JSON.stringify(EXT)]);
							});
							_chekUpdateOrNews();
						}
					});
				});	
			});
		});
		
	};
	

	//Public function for show main body
	GAM.prototype.showMain = function(duration, onloaded){
		return _showMain(duration, onloaded);
	};	

	GAM.prototype.showBoard = function(){
		return _showBoard();
	};	

	_gaq.push(['_trackEvent', "Main Popup", "Opened", JSON.stringify(EXT)]);

})(window,document,jQuery,CORE,SCORE,GLB);







